Subject: Re: _High_ CPU usage while routing (mostly) small UDP packets

From: Karsten Desler <[email-masked]>
Date: Tue, 7 Dec 2004 19:38:45 +0100

Karsten Desler <[email-masked]> wrote:
> > Also have a look at http://www.hipac.org/ as netfilter
> > has silly scalability properties.
> 
> I did before, but I read on Harald Weltes' weblog that 2.4 gives
> slightly worse pps results than 2.6, and since the cpu usage is as high
> as it is, I didn't want to take any more performance hits.
> I'll try to see what performance impact the netfilter rules have during
> peak load.

using 2 CPUs
System load: 61.4% || Free:  51.0%(0)  26.3%(1)
System load: 59.6% || Free:  53.6%(0)  27.3%(1)
System load: 59.6% || Free:  53.6%(0)  27.3%(1)
System load: 59.7% || Free:  53.6%(0)  27.0%(1)
System load: 60.3% || Free:  53.0%(0)  26.4%(1)
System load: 51.9% || Free:  60.4%(0)  35.8%(1) <- iptables -F
System load: 50.1% || Free:  62.1%(0)  37.7%(1)
System load: 50.1% || Free:  62.0%(0)  37.8%(1)
System load: 50.6% || Free:  61.6%(0)  37.2%(1)
System load: 50.5% || Free:  61.7%(0)  37.3%(1)

> > I also notice that a lot of time is spent allocating
> > and freeing the packet buffers (and possible hidden
> > time due to cache misses due to allocating on one
> > CPU and freeing on another?).
> > How many [RT]xDescriptors do you have configured by the way?
> 
> 256. I increased them to 1024 shortly after the profiling run, but
> didn't notice any change in the cpu usage (will try again with cyclesoak).

Again, no effect.

Cheers,
 Karsten